(function() {
    var config = window.itrium.config;

    $(".itrium-organization-field").each(function() {
        var valueInput = $(this).find(".itrium-organization-value");
        var organizationsInput = $(this).find(".itrium-organization-organizations-input");
        var departmentsInput = $(this).find(".itrium-organization-departments-input");
        var organizationsMultipleChoice = organizationsInput.attr("data-multipleChoice") === "true";
        var departmentsMultipleChoice = departmentsInput.attr("data-multipleChoice") === "true";
        var departmentsNotLinked = departmentsInput.attr("data-notLinked") === "true";

        function updateValue() {
            var organizationsString = organizationsInput.val();
            var departmentsString = departmentsInput.val();
            valueInput.val(organizationsString + "/" + departmentsString);
            console.log(valueInput.val());
        }

        organizationsInput.selectize({
            maxItems: organizationsMultipleChoice ? undefined : 1,
            delimiter: ',',
            sortField: [{
                field: "text",
                direction: "asc"
            }],
            plugins: [ "remove_button" ]
        });
        var organizationsSelectize = organizationsInput[0].selectize;

        departmentsInput.selectize({
            maxItems: departmentsMultipleChoice ? undefined : 1,
            delimiter: ',',
            sortField: [{
                field: "text",
                direction: "asc"
            }],
            plugins: [ "remove_button" ]
        });
        var departmentsSelectize = departmentsInput[0].selectize;
        departmentsSelectize.disable();

        var departmentsSelectizeNextValue = null;

        var lastOrganizationsValue = null;
        organizationsSelectize.on("change", function(value) {
            var organizationsString = organizationsSelectize.getValue()
            if (lastOrganizationsValue == organizationsString) {
                if (departmentsSelectizeNextValue) { // update departments
                    departmentsSelectize.setValue(departmentsSelectizeNextValue);
                    departmentsSelectizeNextValue = null;
                }
                return;
            }
            lastOrganizationsValue = organizationsString;

            if (organizationsString == "") {
                departmentsSelectize.clear();
                departmentsSelectize.disable();
            } else {
                new ultima.AjaxRequest({
                    type: "GET",
                    url: departmentsNotLinked
                        ? config.urls.ALL_DEPARTMENTS
                        : config.urls.DEPARTMENTS_OF_ORGANIZATION(organizationsString)
                }).done(function(departments) {
                    departmentsSelectize.enable();
                    departmentsSelectize.clear();
                    departmentsSelectize.clearOptions();

                    departmentsSelectize.load(function(callback) {
                        callback(departments.sort(function(a, b) {
                            if (a.name < b.name) return -1;
                            else if (a.name > b.name) return 1;
                            return 0;
                        }).map(function(department) {
                            return {
                                value: department.id,
                                text: department.name
                            };
                        }));
                    });

                    if (departmentsSelectizeNextValue) {
                        departmentsSelectize.setValue(departmentsSelectizeNextValue);
                        departmentsSelectizeNextValue = null;
                    }
                }).fail(function() {

                });
            }

            updateValue();
        });

        departmentsSelectize.on("change", function() {
            updateValue();
        });

        valueInput.on("change", function() {
            var currentValue = valueInput.val();
            var parts = currentValue.split("/");
            if (parts.length < 2 || parts[0] == "") {
                organizationsSelectize.clear();
                departmentsSelectize.clear();
                departmentsSelectize.clearOptions();
                departmentsSelectize.disable();
            } else {
                departmentsSelectizeNextValue = parts[1].split(","); // value would be set after departments will be loaded
                console.log("departmentsSelectizeNextValue=", departmentsSelectizeNextValue)

                var organizations = parts[0].split(",");
                organizationsSelectize.setValue(organizations, true);
            }
        });
    });

    // yep, inserting same content to all <select>'s
    new ultima.AjaxRequest({
        type: "GET",
        url: config.urls.ALL_ORGANIZATIONS
    }).done(function(organizations) {
        var sortedOrganizations = organizations.sort(function(a, b) {
            if (a.name < b.name) return -1;
            else if (a.name > b.name) return 1;
            return 0;
        });

        $(".itrium-organization-organizations-input").each(function() {
            var selectize = $(this)[0].selectize;
            if (selectize == null) { // selectize() inherits all classes from input upon application
                return;
            }
            selectize.load(function(callback) {
                callback(sortedOrganizations.map(function(department) {
                    return {
                        value: department.id,
                        text: department.name
                    };
                }));
            });
        });
    }).fail(function(e) {
        console.error(e);
    });
})();