package extensions.reports.itrium

import extensions.reports.generic.AbstractJasperFormField
import net.sf.jasperreports.engine.JRParameter
import play.twirl.api.Html
import utils.reports.FieldProperties

class NeyrossNodeFormField extends AbstractJasperFormField {

  private var isMultiple: Boolean = false

  def this(jrParameter: JRParameter, multiple: Boolean) = {
    this()
    this.keyValue = jrParameter.getName
    this.titleValue = jrParameter.getDescription
    this.isMultiple = multiple
  }

  override def init(jrParameter: JRParameter): Unit = {
    super.init(jrParameter)
    isMultiple = getParameterProperty(jrParameter, FieldProperties.MULTIPLE).map(_.toBoolean).getOrElse(false)
  }

  override def render(): Html = {
    views.html.reports.itrium.neyrossNodeFormField(key(), isMultiple)
  }

  override def parse(value: String): AnyRef = {
    if (isMultiple) {
      value
    } else {
      try {
        Integer.valueOf(value)
      } catch {
        case t: Throwable =>
          null
      }
    }
  }
}
