package models.reports.itrium

import scala.collection.mutable.ListBuffer

case class NeyrossNode(id: Long, name: String) {}

class NeyrossNodeComponent() {
  def listNeyrossNodes()(implicit connection: java.sql.Connection): Iterable[NeyrossNode] = {
    val sql = "SELECT e.element_id,e.element_name FROM elements AS e JOIN elements_link AS el " +
      "ON e.element_id = el.child_id AND e.type_id <> 8928 WHERE el.parent_id " +
      "IN (SELECT element_id FROM elements WHERE type_id = 8571) " +
      "ORDER BY e.element_name ASC"
    val statement = connection.createStatement()
    val resultSet = statement.executeQuery(sql)

    val resultListBuffer = ListBuffer[NeyrossNode]()

    while (resultSet.next()) {
      val id = resultSet.getInt("element_id")
      val name = resultSet.getString("element_name")
      resultListBuffer += NeyrossNode(id, name)
    }

    resultListBuffer.toSeq
  }
}