import sbt.Keys._

resolvers += "JasperReports Repo 1" at "http://jaspersoft.artifactoryonline.com/jaspersoft/jr-ce-releases/"
resolvers += "JasperReports Repo 2" at "http://jaspersoft.artifactoryonline.com/jaspersoft/third-party-ce-artifacts/"

lazy val makeDeploymentTask: TaskKey[Unit] = TaskKey[Unit]("makeDeployment", "Packages reports deployment")

makeDeploymentTask := {
  import sys.process._
  val isWindows = sys.props("os.name").toLowerCase.contains("windows")
  if (isWindows) {
    Seq("deployment/make.bat")!
  } else {
    Seq("bash", (file(".") / "deployment/make.sh").getAbsolutePath)!
  }
}

lazy val root = (project in file("."))
  .enablePlugins(PlayScala, SbtWeb)
  .settings(
    name := "ultima-reports-itrium",
    scalaVersion := "2.11.8",
    version := "0.7.3",
    organization := "ru.itrium.ultima",
    libraryDependencies ++= Seq(
      "ru.itrium.ultima" %% "ultima-reports-api" % "1.1.7"
    )
  )