(function() {
	var config = window.itrium.config;

	$(".itrium-enumeratedProperty-field").each(function() {
		var input = $(this).find("input");
		var propertyId = input.attr("data-propertyId");
		var multipleChoice = input.attr("data-multipleChoice").toLowerCase() === "true";

		input.selectize({
			maxItems: multipleChoice ? undefined : 1,
			delimiter: ',',
			sortField: [{
				field: "text",
				direction: "asc"
			}],
			plugins: [ "remove_button" ]
		});
		var selectize = input[0].selectize;
		selectize.disable();

		// handle preset restoration
		var lastValue = null;
		input.on("change", function() {
			var currentValue = input.val();
			if (lastValue != currentValue) { // 'silent' tag in selectize.setValue() doesn't work
				lastValue = currentValue;
				var items = input.val().split(",");
				selectize.setValue(items, true);
			}
		});

		new ultima.AjaxRequest({
			type: "GET",
			url: config.urls.ENUMERATED_PROPERTY_OPTIONS(propertyId)
		}).done(function(options) {
			selectize.enable();
			selectize.clear();
			selectize.clearOptions();
			selectize.load(function(callback) {
				callback(options.sort(function(a, b) {
					if (a.value < b.value) return -1;
					else if (a.value > b.value) return 1;
					return 0;
				}).map(function(option) {
					return {
						value: option.id,
						text: option.value
					};
				}));
			});
		}).fail(function() {
			console.error("failed to load enumerated property options");
		});
	});
}());