(function() {
	var config = window.itrium.config;

	$(".itrium-neyrossNode-field").each(function() {
		var input = $(this).find(".itrium-neyrossNode-input");
		var multipleChoice = $(this).find(".itrium-neyrossNode-multipleChoice").val() == "true";

		input.selectize({
			maxItems: multipleChoice ? undefined : 1,
			delimiter: ",",
			sortField: [{
				field: "text",
				direction: "asc"
			}],
			plugins: [ "remove_button" ]
		});
		var selectize = input[0].selectize;
		selectize.disable();

		// handle preset restoration
		var lastValue = null;
		input.on("change", function() {
			var currentValue = input.val();
			if (lastValue != currentValue) { // 'silent' tag in selectize.setValue() doesn't work
				lastValue = currentValue;
				var items = input.val().split(",");
				selectize.setValue(items, true);
			}
		});

		new ultima.AjaxRequest({
			type: "GET",
			url: config.urls.NEYROSS_NODES
		}).done(function(neyrossNodes) {
			selectize.enable();
			selectize.clear();
			selectize.clearOptions();
			selectize.load(function(callback) {
				callback(neyrossNodes.sort(function(a, b) {
					if (a.name < b.name) return -1;
					else if (a.name > b.name) return 1;
					return 0;
				}).map(function(neyrossNode) {
					return {
						value: neyrossNode.id,
						text: neyrossNode.name
					};
				}));
			});
		}).fail(function() {

		});
	});
}());